unit LOGI_Roby3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SPIRIT, Menus,RCXdata,LogiHelp, ExtCtrls,Grid,Slots;

type
  TFormLogi = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Spirit1: TSpirit;
    ListBox1: TListBox;   {only used for tests}
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Panel1: TPanel;
    Image1: TImage;
    Button2: TButton;
    Installieren1: TMenuItem;
    Hilfe1: TMenuItem;
    Slot1: TMenuItem;
    PLOTTERprogram1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Spirit1DownloadDone(Sender: TObject; ErrorCode,
      DownloadNo: Smallint);
    procedure Memo1Change(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Help1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Slot1Click(Sender: TObject);
    procedure PLOTTERprogram1Click(Sender: TObject);
  private
    { Private declarations }
    procedure error(error_code:integer);
    function AnalyseCommand(buffer:string):boolean;
    procedure doTheAnalyse;
    function testports:boolean;
    function testpadpos(argument:real):integer;
    procedure clear_image;
    procedure draw_turtle;
    procedure draw_lines;
    procedure Execute_code(start,finish:integer);
  public
    { Public declarations }
  end;

var
  FormLogi: TFormLogi;

implementation

{$R *.DFM}
type TActualText=(Command_,Param_);
type TCC=array[0..1]of string[10];
const n:integer=28;
      LOGI_Instruction:array[1..28] of string[10]=('FORWARD','LEFT','RIGHT','REPEAT',
   'PEN','DIRECTION',']','UP','DOWN','GAMMA','DELTA','EPSILON','N','W','E','S','NW',
   'NE','SW','SE','NNW','NWW','SSW','SWW','NNE','NEE','SSE','SEE');

const Lego_rotation_type=4;   // sensors
      sensor_x=2;
      sensor_y=0;

      x_motor='2';    // motors
      y_motor='0';
      both_motors='02';
      pen_motor='1';


const forward_=0;        // subroutines
      left_=1;
      right_=2;
      pen_=3;
      cap_=4;

      break=5;

const procedure_=1;        // tasks
      reset_x=2;
      reset_y=3;
      touch_event=4;
      out_of_range_event=5;
      way_length=6;  //started through forward-sub
      motor_x_control=7;   //started through forward-sub
      motor_y_control=8;


const argument=0;        // variables
      direction=1;       //angle
      rotations_per_10=2;   //corresponds to the screen-unit

      x_touch=5;   //variables needed in touch_event
      y_touch=6;
      t_event=7;
      t_temp=8;    //local variable

      dx=9;    //actual variation starting every-time forward-sub is called
      dy=10;
      L_sqr=11; //square of the magnitude passed through argument in forward-sub

      phi=13;
      dist=14;  //=dx^2+dy^2
      w_temp1=15;     //local variable
      w_temp2=16;     //local variable
      old_pos_x=17;
      old_pos_y=18;

      case_=19;

      Motor_on=22;
      Motor_off=23;
      m_temp=24;


      



var commandcode,buffer,buff:string;
    compiledCodeCount,MainIndex,StartCommandIndex,
    StartSelectionIndex,endCommandIndex,grid_step,grid_width,start_x,start_y,
    repeat_level_counter,Zoom:integer;
    alpha,posx,posy:real;
    compiledCode:array[1..2000]of TCC;
    ActualText:TActualText;
    WaitForCommand,WaitForParam,alreadyError,first,dirty,Star,pen_UP:boolean;

    
procedure TFormLogi.Button1Click(Sender: TObject);

var open_,close_,idx0,idx1:integer;
    ActualChar:char;
     comment_flag:boolean;
label 1;
begin
  pen_up:=true;
  repeat_level_counter:=0;
  alreadyerror:=false;
  listbox1.clear;
   star:=false;
  if not memo1.focused then memo1.setfocus;
  compiledCodeCount:=0;
  WaitForCommand:=true;  {flag that indicates whether LOGI expects a command}
  WaitForParam:=false;  {flag that indicates whether LOGI expects a command}
  ActualText:=Command_;
  first:=true;  {the first blanks before the first command don't count}
  if memo1.lines.count>2000 then begin error(12);exit;end; {too many lines}
  if memo1.lines.count<1 then begin error(0);exit;end else  {if memo empty}
     begin

       open_:=0;close_:=0; {counters for opened and closed brakets}
       buffer:='';         {resets the buffer}
       mainindex:=-2;  {needed for error treatment}
       for idx0:=0 to memo1.lines.count-1 do     {scan the memo}
           begin
             comment_flag:=false;
             if alreadyerror then exit;
             mainindex:=mainindex+2;{counts the memo1.text property with linefeed}
             dotheAnalyse;
             for idx1:=1 to length(memo1.lines[idx0]) do {scan the actual line}
                begin

                  mainindex:=mainindex+1;   {next character}
                  actualchar:=memo1.lines[idx0][idx1];
               {------------------------------------------------------}
                 if actualchar='/' then comment_flag:=true;
                 if comment_flag then goto 1; {hue!! goto igitt!}
                   if actualchar='*' then star:=true;
                   if actualchar='[' then  open_:=open_+1 else


                   if (actualchar<>' ')and(actualchar<>'*') then
                     begin
                      if WaitForCommand then
                        begin
                         StartCommandIndex:=MainIndex; {to know where we are}
                         StartSelectionIndex:=MainIndex; {for selection use}
                         WaitForCommand:=false;
                         first:=false;
                        end;

                      if WaitForParam then
                        begin
                         StartSelectionIndex:=MainIndex;
                         waitForParam:=false;
                         first:=false;
                        end;


                      if actualchar=']' then  close_:=close_+1;
                       if close_>open_ then begin error(13);exit;end;

                      buffer:=buffer+actualchar;

                    end else dotheanalyse;
                  1: {if comment}
                end;
           end;
       if open_<>close_ then begin error(7);exit;end;
       if not star then begin error(8);exit;end;
     end;
  if not alreadyerror then draw_lines;
end;
  {-------------------------------------------------------}
procedure TFormLogi.Button2Click(Sender:TObject);
var idx0:integer;
begin
button1click(sender);
if not alreadyerror then
if testports then
  with spirit1 do
  begin

    selectprgm(formslot.radiogroup1.itemindex);
    beginoftask(1);
    setvar(direction,con,0); //equivalent to alpha, has to be reset

    if compiledCodeCount>0 then
    for idx0:=1 to compiledCodeCount do
     begin
       if compiledCode[idx0][0]='F' then
          begin setvar(0,2,strToint(compiledCode[idx0][1]));gosub(forward_); end;
       if compiledCode[idx0][0]='L' then
          begin
           setvar(argument,2,strToint(compiledCode[idx0][1]));
           gosub(Left_);
          end;
       if compiledCode[idx0][0]='R' then
          begin
           setvar(argument,2,strToint(compiledCode[idx0][1]));
           gosub(Right_);
          end;
       if compiledCode[idx0][0][1]='D' then
          begin loop(2,strToint(compiledCode[idx0][1])); end;
       if compiledCode[idx0][0]='P' then
          begin setvar(0,2,strToint(compiledCode[idx0][1]));gosub(pen_); end;
       if compiledCode[idx0][0]='K' then
          begin
           setvar(argument,2,strToint(compiledCode[idx0][1]));
           gosub(Cap_);
          end;
       if compiledCode[idx0][0][1]=']' then endloop;
      end;

    EndOfTask();

  end else messagedlg('Communicationproblem',mterror,[mbOK],0);
end;

procedure TFormLogi.doTheAnalyse;
begin
                      if not first then
                        begin
                         first:=true;
                         if not AnalyseCommand(buffer) then
                                   begin error(1);exit;end;


                         case actualText of
                            Command_: begin
                                       actualText:=Param_; {toggle}
                                       waitForParam:=true;
                                       waitForCommand:=false;
                                       endCommandIndex:=mainIndex;
                                       compiledCodeCount:=CompiledCodeCount+1;
                                       if commandcode='D' then
                                         begin
                                          Repeat_level_counter:=
                                            Repeat_level_counter+1;
                                          commandcode:=commandcode+
                                             intTostr(Repeat_level_counter);
                                         end;
                                       if commandcode=']' then
                                           begin
                                           commandcode:=commandcode+
                                             intTostr(Repeat_level_counter);
                                            Repeat_level_counter:=
                                            Repeat_level_counter-1;

                                           end;
                                       compiledCode[compiledcodecount][0]:=
                                                 commandcode;

                                       buff:=commandcode+' ';

                                       if commandcode[1]=']' then
                                         begin

                                           actualText:=Command_; {toggle}
                                           waitForParam:=false;
                                           waitForCommand:=True;
                                           endCommandIndex:=mainIndex;
                                       compiledCode[compiledcodecount][1]:='0';
                                           buff:=buff+'0';

                                           listbox1.items.add(buff);
                                         end;
                                      end;
                            Param_: begin
                                      actualText:=Command_; {toggle}
                                      waitForParam:=false;
                                      waitForCommand:=True;
                                      endCommandIndex:=mainIndex;
                               compiledCode[compiledcodecount][1]:=commandcode;
                                      buff:=buff+commandcode;

                                      listbox1.items.add(buff);

                                    end;
                           end; {case}
                         buffer:=''; {clear buffer}
                        end;
                    end;

procedure TFormLogi.error(error_code:integer);
var mess:string;
begin
if not alreadyError then
begin

 memo1.selstart:=startselectionIndex-1;
 memo1.sellength:=mainIndex-startselectionIndex;
 alreadyError:=true;        {this needed to avoid two error_messages}
 case error_code of
 0:mess:='No Code';
 1:mess:='Code error';
 7:mess:='Check [ ] brakets';
 8:mess:='Programm must end with a sole *';
 10:mess:='Unknown command';
 11:mess:='Wrong number';
 12:mess:='Too many lines!';
 13:mess:='Problem with brakets!';
 15:mess:='Number out of range!';
 30:mess:='Unknown parameter';
 32:begin mess:='Number of REPEATs must be positive!';
           memo1.selstart:=0; memo1.sellength:=length(memo1.text);end;
 end;
 messageDlg('Error : '+mess,mtError,[mbOK],0);

end;
end;

function TFormLogi.AnalyseCommand(buffer:string):boolean;
var idx,foundindex:integer;
number:Longint;
    s1,s2:array[0..79]of char;
    s0:string;
begin
  foundindex:=-1;
 commandcode:='';
 number:=-100000;
 try
 number:=strtoint(buffer);
 if (number>32767)or(number<-32768) then begin error(15);exit;end;
 commandcode:=buffer;
 except on EConvertError do
  begin
    number:=0;
    foundindex:=0;
    idx:=0;
    StrPCopy(s1,buffer);
   repeat
     idx:=idx+1;
     s0:=LOGI_Instruction[idx];
     strPCopy(s2,s0);
     if (StrLIComp(s1,s2,length(s0))=0)and (length(s0)=length(buffer)) then
         foundindex:=idx;
        {case insensitive comparison}
  until (idx>=n)or(foundindex>=1);   //don't forget here is n
   if foundIndex>=1 then commandCode:=LOGI_Instruction[foundIndex];
  end;
 end;  {try}
 case ActualText of
  command_: begin
             if foundindex>7 then begin error(10);exit;end;
             if number<-40000 then begin error(11);exit;end;
             
            end;
  param_:   begin
             if (foundindex<=7)and(foundindex>=1) then begin error(30);exit;end;
            end;
  end; {case}
 if commandcode='PEN' then commandcode:='P';
 if commandcode='DIRECTION' then commandcode:='K';
 if commandcode='UP' then commandcode:='0';
 if commandcode='DOWN' then commandcode:='1';
 if commandcode='GAMMA' then commandcode:='2';
 if commandcode='DELTA' then commandcode:='3';
 if commandcode='EPSILON' then commandcode:='4';
 if commandcode='REPEAT' then commandcode:='D';
 if commandcode='FORWARD' then commandcode:='F';
 if commandcode='RIGHT' then commandcode:='R';
 if commandcode='LEFT' then commandcode:='L';
 if commandcode='N' then commandcode:='0';
 if commandcode='E' then commandcode:='90';
 if commandcode='S' then commandcode:='180';
 if commandcode='W' then commandcode:='270';
 if commandcode='NW' then commandcode:='315';
 if commandcode='NE' then commandcode:='45';
 if commandcode='SW' then commandcode:='225';
 if commandcode='SE' then commandcode:='135';
 if commandcode='NNW' then commandcode:='338';
 if commandcode='NWW' then commandcode:='293';
 if commandcode='SSW' then commandcode:='203';
 if commandcode='SWW' then commandcode:='248';
 if commandcode='NNE' then commandcode:='23';
 if commandcode='NEE' then commandcode:='68';
 if commandcode='SSE' then commandcode:='158';
 if commandcode='SEE' then commandcode:='113';
 if commandcode<>'' then result:=true else result:=false;

end;



procedure TFormLogi.Spirit1DownloadDone(Sender: TObject; ErrorCode,
  DownloadNo: Smallint);
begin

 if errorcode=0 then spirit1.playSystemsound(3) else
   messagedlg('An error occured while transmitting task '+inttostr(DownLoadNo),
      mterror,[mbOK],0);

end;

function TFormLogi.testports:boolean;
var Comidx,ComPort: smallInt;
    testPort,ready:boolean;   {testport only true if Tower well connected and working}
begin

testPort:=false;

for Comidx:=1 to 4 do             {test all ports}
if not testport then
 begin
  application.processmessages;
  ready:=true;
  spirit1.ComPortNo:=ComIdx;
  If spirit1.initComm then        {first test the communication}
    begin
      if spirit1.TowerAndCableConnected then    {test the connection}
         begin
           Comport:=Comidx;
           testPort:=true;
         end else Ready:=false;
    end else  Ready:=false;
 end;

       if ready then
             if spirit1.TowerAlive then         {test the tower}

                  If not spirit1.PBAliveOrNot then   {test the RCX}
                                         ready:=false;

  result:=ready;

end;

procedure TFormLogi.Memo1Change(Sender: TObject);
begin
 dirty:=true;
end;

procedure TFormLogi.New1Click(Sender: TObject);
begin
if dirty then
 if messagedlg('Do you want to save?', mtConfirmation,[mbYes,mBno],0)=mrYes
   then save1click(sender);
 memo1.clear;
 listbox1.clear;
 dirty:=false;
 FormPaint(Sender);
 FormLogi.caption:='LOGI';
 memo1.setfocus;
 savedialog1.filename:='';
end;

procedure TFormLogi.Open1Click(Sender: TObject);
begin
if dirty then
 if messagedlg('Do you want to save?', mtConfirmation,[mbYes,mBno],0)=mrYes
   then save1click(sender);

if opendialog1.execute then
begin
  formPaint(sender);
 FormLogi.caption:='LOGI '+opendialog1.filename;
 listbox1.clear;
 memo1.lines.loadfromfile(opendialog1.filename);
 savedialog1.filename:=opendialog1.filename;
 dirty:=false;
 memo1.setfocus;
end;
end;

procedure TFormLogi.SaveAs1Click(Sender: TObject);
begin
if savedialog1.execute then
  begin
    formLogi.caption:='LOGI '+savedialog1.filename;
    memo1.lines.savetofile(savedialog1.filename);
    dirty:=false;
    memo1.setfocus;
  end;
end;

procedure TFormLogi.Save1Click(Sender: TObject);
begin
if savedialog1.filename='' then saveas1click(sender) else
  begin
    memo1.lines.savetofile(savedialog1.filename);
    dirty:=false;
    memo1.setfocus;
  end;
end;

procedure TFormLogi.FormCreate(Sender: TObject);
begin
 dirty:=false;
 image1.picture.bitmap.width:=700;
 image1.picture.bitmap.height:=600;
 grid_width:=1; 
 alpha:=0;
 Zoom:=10;
 start_x:=4;start_y:=0;
 pen_up:=true;
end;


procedure TFormLogi.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if dirty then
 if messagedlg('Do you want to save?', mtConfirmation,[mbYes,mBno],0)=mrYes
   then save1click(sender);
end;

procedure TFormLogi.Help1Click(Sender: TObject);
begin
  FormHelp.show;
end;

procedure TFormLogi.FormPaint(Sender: TObject);
begin
 memo1.left:=2;                         {adjusts the window-controls}
 memo1.width:=(formLogi.width Div 3)-4;
 memo1.height:=formLogi.height-150;
 panel1.left:=memo1.width+4;
 panel1.width:=2*memo1.width-4;
 panel1.height:=9*panel1.width div 10;
 button1.left:=(formLogi.width div 4)-(button1.width div 2);
 button1.top:=(memo1.height+30);
 button2.left:=((3 * formLogi.width) div 4)-(button1.width div 2);
 button2.top:=button1.top;
 spirit1.top:=button2.top+10;
 spirit1.left:=(formLogi.width div 2)-18;
 grid_step:=image1.width div ZOOM;
 start_x:=4;
 start_y:=image1.height;
 clear_image;
 draw_turtle;

end;

procedure TFormLogi.FormResize(Sender: TObject);
begin
 formpaint(sender);
end;

procedure TFormLogi.Clear_Image;
var idx:integer;
begin

 with image1.picture.bitmap.canvas do
 begin
   pen.width:=1;
   pen.color:=clblack;
   brush.color:=clwhite;
   rectangle(0,0,700,600);  {clears the test-pad}

   pen.color:=clsilver;
   for idx:=1 to ZOOM do
     begin
       moveto(idx*grid_step,0);
       lineto(idx*grid_step,image1.height);
     end;
   for idx:=1 to image1.height div grid_step do
      begin
       moveto(0,idx*grid_step);
       lineto(image1.width,idx*grid_step);
      end;
   pen.color:=clnavy;
   case grid_width of
   1:   textout(23,25,'1 cm');
   end;



  end; {with}
 alpha:=0; {reset the angle}
 image1.picture.bitmap.canvas.moveto(start_x,start_y);
posx:=start_x;posy:=start_y;
end;

function TFormLogi.testpadpos(argument:real):integer;    {converts values to pixels}
begin
  {1 grid_step = grid_width}
  result:=round(argument*grid_step/grid_width);
end;

procedure TFormLogi.draw_turtle;
var delta:integer;
    myrect:Trect;
begin
image1.picture.bitmap.canvas.brush.color:=clred;
image1.picture.bitmap.canvas.ellipse(start_x,start_y,start_x+8,start_y-8);
posx:=start_x;posy:=start_y;
end;

procedure TFormLogi.Draw_Lines;
var start,finish:integer;
begin
clear_image;
start:=1;finish:=compiledcodeCount;
 if compiledCodeCount>0 then execute_code(start,finish);
end;

procedure TFormLogi.Execute_code(start,finish:integer);
var argument:real;
    idx0,idx1,idx2,Repeat_level,skip_index:integer;
    skip,found:boolean;
    function extract_level_counter(i:integer):integer;
    var idx:integer;
        s:string[10];
    begin
    s:='';
     for idx:=2 to length(compiledCode[i][0]) do s:=s+compiledCode[i][0][idx];
     result:=strToint(s);

    end;
begin
if not alreadyerror then
begin
  image1.picture.bitmap.canvas.pen.width:=2;
  skip:=false;found:=false;
     for idx0:=start to finish do
     begin
     if not skip then
      begin
       if compiledCode[idx0][0]='F' then
               begin
                if pen_up then image1.picture.bitmap.canvas.pen.color:=clgray
                 else  image1.picture.bitmap.canvas.pen.color:=clnavy;
                argument:=strToint(compiledCode[idx0][1])/10;
                posx:=posx+sin(alpha*pi/180)*testpadpos(argument);
                posy:=posy-cos(alpha*pi/180)*testpadpos(argument);
                image1.picture.bitmap.canvas.lineto(round(posx),round(posy));
               end;
       if compiledCode[idx0][0]='L' then
               begin alpha:=alpha-strToint(compiledCode[idx0][1]); end;
       if compiledCode[idx0][0]='R' then
               begin alpha:=alpha+strToint(compiledCode[idx0][1]); end;
       if compiledCode[idx0][0]='K' then
               begin alpha:=strToint(compiledCode[idx0][1]); end;
       if compiledCode[idx0][0]='P' then
               begin
                with image1.picture.bitmap.canvas do
                  begin
                    case strToint(compiledCode[idx0][1]) of
                      0: begin brush.color:=clfuchsia;pen_up:=true;end;
                      1: begin brush.color:=cllime;pen_up:=false;end;
                    end;
                  ellipse(round(posx-2*pen.width),round(posy-2*pen.width),
                     round(posx+2*PEN.width),round(posy+2*pen.width));
                  brush.color:=clwhite;
                  moveto(round(posx),round(posy));

                  end;
               end;
       if compiledCode[idx0][0][1]='D' then
          begin
            repeat_level:=extract_level_counter(idx0);
            skip:=true;
            idx1:=idx0-1;
            repeat
              idx1:=idx1+1;
              if  compiledCode[idx1][0][1]=']' then
                if repeat_level=extract_level_counter(idx1) then found:=true;
            until found;   {find out position of ] }
             skip_index:=idx1;
             if strToint(compiledCode[idx0][1])<0 then begin error(32);exit;end;
             if  strToint(compiledCode[idx0][1])=0 then
               for idx2:=1 to 500 do  execute_code(idx0+1,idx1-1) else
            for idx2:=1 to  strToint(compiledCode[idx0][1]) do
                execute_code(idx0+1,idx1-1);

          end;
       end else    {if skip}
         begin
          if skip_index=idx0  then begin skip:=false;found:=false;end;
         end;
     end; {for idx0}
end;
end;



procedure TFormLogi.Slot1Click(Sender: TObject);
begin
  formslot.showmodal;
end;

{=============================================================================}


procedure TFormLogi.PLOTTERprogram1Click(Sender: TObject);
begin
 if testports then
  begin
   with spirit1 do
   begin
    //first set the global variables
    setvar(rotations_per_10,con,14);
    setvar(direction,con,0);
    selectprgm(formslot.radiogroup1.itemindex);

    beginoftask(main);
      setsensortype(sensor_x,Lego_rotation_type); //two rotation-sensors
      setsensortype(sensor_y,Lego_rotation_type);
      setpower(both_motors,con,7);
      starttask(touch_event);
      wait(con,30);
      starttask(reset_x);
      starttask(reset_y);
      while_(var_iable,t_event,eq,con,0); //wait until both pressed
      endwhile();
      playsystemsound(beep_sound);
      clearsensorvalue(sensor_x);  //  reset x_rotation sensor
      clearsensorvalue(sensor_y);  // reset y_rotation sensor
      stoptask(touch_event); //no more needed
      starttask(out_of_range_event);
      starttask(procedure_);
    endoftask();

    //reset tasks ****************************************************

    beginoftask(touch_event);
       setsensortype(sensor_2,no_type); //touch_sensor multiplexer used
       setvar(t_event,con,0);  //clear t_event
       setvar(x_touch,con,0);  //clear x_touch event
       setvar(y_touch,con,0);  //clear y_touch event
     loop(con,forever); //wait until both events happened
       setvar(x_touch,con,0);
       setvar(y_touch,con,0);
       while_(senval,sensor_2,GT,con,990); //wait until touch_event
       endwhile();
       wait(con,10); //wait transition time
       if_(senval,sensor_2,GT,con,860); //y_touch pressed
          setvar(x_touch,con,0);
          setvar(y_touch,con,1);
       else_();
          if_(senval,sensor_2,GT,con,825); //only x_touch pressed
              setvar(x_touch,con,1);
              setvar(y_touch,con,0);
          else_();
              setvar(x_touch,con,1); //both pressed
              setvar(y_touch,con,1);
          endif();
       endif();
       setvar(t_temp,var_iable,x_touch);  //store temporary because of operation
       mulvar(t_temp,var_iable,y_touch);
       setvar(t_event,var_iable,t_temp);
     endloop();

    endoftask();

    beginoftask(reset_x);
      setrwd(x_motor); //  rwd = go home
      on_(x_motor);
      while_(var_iable,x_touch,eq,con,0); //wait until x_touch event
      endwhile();

      off(x_motor);
    endoftask();

    beginoftask(reset_y);
      setrwd(y_motor); //  rwd = go home
      on_(y_motor);
      while_(var_iable,y_touch,eq,con,0); //wait until y_touch event
      endwhile();

      off(y_motor);
    endoftask();

   //out_of_range_event *********************************************
   beginoftask(out_of_range_event);
   loop(con,forever);
     if_(senval,sensor_y,GT,con,15);
       stoptask(motor_x_control);
       stoptask(motor_y_control);
       off(both_motors);
       playsystemsound(error_sound);
       stopalltasks();
     endif();
     if_(senval,sensor_y,LT,con,-1700); //limit
       stoptask(motor_x_control);
       stoptask(motor_y_control);
       off(both_motors);
       playsystemsound(error_sound);
       stopalltasks();
     endif();
     if_(senval,sensor_x,GT,con,15);
       stoptask(motor_x_control);
       stoptask(motor_y_control);
       off(both_motors);
       playsystemsound(error_sound);
       stopalltasks();
     endif();
     if_(senval,sensor_x,LT,con,-1900); //limit
       stoptask(motor_x_control);
       stoptask(motor_y_control);
       off(both_motors);
       playsystemsound(error_sound);
       stopalltasks();
     endif();
   endloop();
   endoftask();

    //now the forward-subroutine ***********************************
    beginofsub(forward_);   //var argument holds the magnitude
       setvar(dx,con,0);  //RAZ
       setvar(dy,con,0);  //RAZ
       setvar(dist,con,0); //RAZ
       setvar(old_pos_x,senval,sensor_x);   //store the actual position
       setvar(old_pos_y,senval,sensor_y);

       setvar(L_sqr,var_iable,argument);    //set the length
       mulvar(L_sqr,var_iable,argument);

       //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       if_(var_iable,direction,LT,con,91);
            setfwd(both_motors);
            if_(var_iable,direction,LT,con,46);
                setvar(case_,con,1);
                setvar(phi,var_iable,direction);
            else_();
                setvar(case_,con,2);
                setvar(phi,con,90);
                subvar(phi,var_iable,direction);
            endif();
       else_();
            if_(var_iable,direction,LT,con,181);
                setfwd(x_motor);
                setrwd(y_motor);
                if_(var_iable,direction,LT,con,136);
                   setvar(case_,con,2);
                   setvar(phi,var_iable,direction);
                   subvar(phi,con,90);
                else_();
                   setvar(case_,con,1);
                   setvar(phi,con,180);
                   subvar(phi,var_iable,direction);
                endif();
            else_();
                if_(var_iable,direction,LT,con,271);
                    setrwd(both_motors);
                    if_(var_iable,direction,LT,con,226);
                       setvar(case_,con,1);
                       setvar(phi,var_iable,direction);
                       subvar(phi,con,180);
                    else_();
                       setvar(case_,con,2);
                       setvar(phi,con,270);
                       subvar(phi,var_iable,direction);
                    endif();
                else_();
                    setrwd(x_motor);
                    setfwd(y_motor);
                    if_(var_iable,direction,LT,con,316);
                       setvar(case_,con,2);
                       setvar(phi,var_iable,direction);
                       subvar(phi,con,270);
                    else_();
                       setvar(case_,con,1);
                       setvar(phi,con,360);
                       subvar(phi,var_iable,direction);
                    endif();
                endif();
            endif();

       endif();

       //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       if_(var_iable,phi,eq,con,1);
         setvar(motor_on,con,1);
         setvar(motor_off,con,57);
       else_();
       //-->
       if_(var_iable,phi,eq,con,2);
         setvar(motor_on,con,1);
         setvar(motor_off,con,29);
       else_();
       //-->
       if_(var_iable,phi,eq,con,3);
         setvar(motor_on,con,1);
         setvar(motor_off,con,19);
       else_();
       //-->
       if_(var_iable,phi,eq,con,4);
         setvar(motor_on,con,1);
         setvar(motor_off,con,15);
       else_();
       //-->
       if_(var_iable,phi,eq,con,5);
         setvar(motor_on,con,1);
         setvar(motor_off,con,12);
       else_();
       //-->
       if_(var_iable,phi,eq,con,6);
         setvar(motor_on,con,2);
         setvar(motor_off,con,19);
       else_();
       //-->
       if_(var_iable,phi,eq,con,7);
         setvar(motor_on,con,2);
         setvar(motor_off,con,17);
       else_();
       //-->
       if_(var_iable,phi,eq,con,8);
         setvar(motor_on,con,1);
         setvar(motor_off,con,7);
       else_();
       //-->
       if_(var_iable,phi,eq,con,9);
         setvar(motor_on,con,3);
         setvar(motor_off,con,19);
       else_();
       //-->
       if_(var_iable,phi,eq,con,10);
         setvar(motor_on,con,1);
         setvar(motor_off,con,6);
       else_();
       //-->
       if_(var_iable,phi,eq,con,11);
         setvar(motor_on,con,4);
         setvar(motor_off,con,21);
       else_();
       //-->
       if_(var_iable,phi,eq,con,12);
         setvar(motor_on,con,4);
         setvar(motor_off,con,19);
       else_();
       //-->
       if_(var_iable,phi,eq,con,13);
         setvar(motor_on,con,3);
         setvar(motor_off,con,13);
       else_();
       //-->
       if_(var_iable,phi,eq,con,14);
         setvar(motor_on,con,1);
         setvar(motor_off,con,4);
       else_();
       //-->
       if_(var_iable,phi,eq,con,15);
         setvar(motor_on,con,4);
         setvar(motor_off,con,15);
       else_();
       //-->
       if_(var_iable,phi,eq,con,16);
         setvar(motor_on,con,2);
         setvar(motor_off,con,7);
       else_();
       //-->
       if_(var_iable,phi,eq,con,17);
         setvar(motor_on,con,3);
         setvar(motor_off,con,10);
       else_();
       //-->
       if_(var_iable,phi,eq,con,18);
         setvar(motor_on,con,2);
         setvar(motor_off,con,6);
       else_();
       //-->
       if_(var_iable,phi,eq,con,19);
         setvar(motor_on,con,1);
         setvar(motor_off,con,3);
       else_();
       //-->
       if_(var_iable,phi,eq,con,20);
         setvar(motor_on,con,4);
         setvar(motor_off,con,11);
       else_();
       //-->
       if_(var_iable,phi,eq,con,21);
         setvar(motor_on,con,3);
         setvar(motor_off,con,8);
       else_();
       //-->
       if_(var_iable,phi,eq,con,22);
         setvar(motor_on,con,2);
         setvar(motor_off,con,5);
       else_();
       //-->
       if_(var_iable,phi,eq,con,23);
         setvar(motor_on,con,5);
         setvar(motor_off,con,12);
       else_();
       //-->
       if_(var_iable,phi,eq,con,24);
         setvar(motor_on,con,4);
         setvar(motor_off,con,9);
       else_();
       //-->
       if_(var_iable,phi,eq,con,25);
         setvar(motor_on,con,6);
         setvar(motor_off,con,13);
       else_();
       //-->
       if_(var_iable,phi,eq,con,26);
         setvar(motor_on,con,1);
         setvar(motor_off,con,2);
       else_();
       //-->
       if_(var_iable,phi,eq,con,27);
         setvar(motor_on,con,1);
         setvar(motor_off,con,2);
       else_();
       //-->
       if_(var_iable,phi,eq,con,28);
         setvar(motor_on,con,9);
         setvar(motor_off,con,17);
       else_();
       //-->
       if_(var_iable,phi,eq,con,29);
         setvar(motor_on,con,6);
         setvar(motor_off,con,11);
       else_();
       //-->
       if_(var_iable,phi,eq,con,30);
         setvar(motor_on,con,4);
         setvar(motor_off,con,7);
       else_();
       //-->
       if_(var_iable,phi,eq,con,31);
         setvar(motor_on,con,3);
         setvar(motor_off,con,5);
       else_();
       //-->
       if_(var_iable,phi,eq,con,32);
         setvar(motor_on,con,5);
         setvar(motor_off,con,8);
       else_();
       //-->
       if_(var_iable,phi,eq,con,33);
         setvar(motor_on,con,9);
         setvar(motor_off,con,14);
       else_();
       //-->
       if_(var_iable,phi,eq,con,34);
         setvar(motor_on,con,2);
         setvar(motor_off,con,3);
       else_();
       //-->
       if_(var_iable,phi,eq,con,35);
         setvar(motor_on,con,7);
         setvar(motor_off,con,10);
       else_();
       //-->
       if_(var_iable,phi,eq,con,36);
         setvar(motor_on,con,5);
         setvar(motor_off,con,7);
       else_();
       //-->
       if_(var_iable,phi,eq,con,37);
         setvar(motor_on,con,3);
         setvar(motor_off,con,4);
       else_();
       //-->
       if_(var_iable,phi,eq,con,38);
         setvar(motor_on,con,7);
         setvar(motor_off,con,9);
       else_();
       //-->
       if_(var_iable,phi,eq,con,39);
         setvar(motor_on,con,4);
         setvar(motor_off,con,5);
       else_();
       //-->
       if_(var_iable,phi,eq,con,40);
         setvar(motor_on,con,5);
         setvar(motor_off,con,6);
       else_();
       //-->
       if_(var_iable,phi,eq,con,41);
         setvar(motor_on,con,6);
         setvar(motor_off,con,7);
       else_();
       //-->
       if_(var_iable,phi,eq,con,42);
         setvar(motor_on,con,9);
         setvar(motor_off,con,10);
       else_();
       //-->
       if_(var_iable,phi,eq,con,43);
         setvar(motor_on,con,13);
         setvar(motor_off,con,14);
       else_();
       //-->
       if_(var_iable,phi,eq,con,44);
         setvar(motor_on,con,28);
         setvar(motor_off,con,29);
       else_();
       //-->
       if_(var_iable,phi,eq,con,45);
         setvar(motor_on,con,1);
         setvar(motor_off,con,1);


       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();
       endif();

       if_(var_iable,case_,eq,con,2);  //swap motor_on and motor_off
         setvar(m_temp,var_iable,motor_on);
         setvar(motor_on,var_iable,motor_off);
         setvar(motor_off,var_iable,m_temp);
       endif();
       //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       starttask(way_length);    //start integrating
       wait(con,30);

       starttask(motor_x_control);
       starttask(motor_y_control);
       while_(var_iable,dist,LT,var_iable,L_sqr);
       endwhile(); //wait until target reached
       stoptask(motor_x_control);
       stoptask(motor_y_control);
       stoptask(way_length);
       off(both_motors);
    endofsub();

    //way-integration *********************************************
    beginoftask(way_length);
    loop(con,forever);
      setvar(w_temp1,senval,sensor_x);     //calculate dx=actualpos-off-set
      subvar(w_temp1,var_iable,old_pos_x);
      setvar(dx,var_iable,w_temp1);
      divvar(dx,var_iable,rotations_per_10);

      setvar(w_temp2,senval,sensor_y);     //calculate dy=actualpos-off-set
      subvar(w_temp2,var_iable,old_pos_y);
      setvar(dy,var_iable,w_temp2);
      divvar(dy,var_iable,rotations_per_10);

      setvar(w_temp1,var_iable,dx);
      mulvar(w_temp1,var_iable,dx);
      setvar(w_temp2,var_iable,dy);
      mulvar(w_temp2,var_iable,dy);
      sumvar(w_temp1,var_iable,w_temp2);
      setvar(dist,var_iable,w_temp1); //dist=dx^2+dy^2

    endloop();
    endoftask();

    //motor-control ***********************************************
    beginoftask(motor_x_control);

    loop(con,forever);
        if_(var_iable,phi,eq,con,0);
           if_(var_iable,case_,eq,con,2);
               on_(x_motor);
           endif();
        else_();
           if_(var_iable,phi,eq,con,45);
               on_(x_motor);
           else_();
             loop(var_iable,motor_on);
               on_(x_motor);
             endloop();
             loop(var_iable,motor_off);
               off(x_motor);
             endloop();
           endif();
       endif();

    endloop();
    endoftask();

    beginoftask(motor_y_control);
    loop(con,forever);
       if_(var_iable,phi,eq,con,0);
           if_(var_iable,case_,eq,con,1);
               on_(y_motor);
           endif();
        else_();
           if_(var_iable,phi,eq,con,45);
               on_(y_motor);
           else_();
             loop(var_iable,motor_off);
                  on_(y_motor);
             endloop();
             loop(var_iable,motor_on);
                off(y_motor);
             endloop();
           endif();
       endif();

    endloop();
    endoftask();

beginofsub(left_);
  while_(var_iable,argument,GT,con,180);   //argument must be <=180
    subvar(argument,con,360);
  endwhile();
  while_(var_iable,argument,LT,con,-180);    //argument must be >=-180
    sumvar(argument,con,360);
  endwhile();
  subvar(direction,var_iable,argument);      //substract to direction
  while_(var_iable,direction,GT,con,360);   //direction must be <=360
   subvar(direction,con,360);
  endwhile();
  while_(var_iable,direction,LT,con,0);     //direction must be >=0
   sumvar(direction,con,360);
  endwhile();

endofsub();

beginofsub(right_);
  while_(var_iable,argument,GT,con,180);   //argument must be <=180
    subvar(argument,con,360);
  endwhile();
  while_(var_iable,argument,LT,con,-180);    //argument must be >=-180
    sumvar(argument,con,360);
  endwhile();
  sumvar(direction,var_iable,argument);    //add to direction
  while_(var_iable,direction,GT,con,360);   //direction must be <=360
   subvar(direction,con,360);
  endwhile();
  while_(var_iable,direction,LT,con,0);     //direction must be >=0
   sumvar(direction,con,360);
  endwhile();

endofsub();

beginofsub(Cap_);
 while_(var_iable,argument,GT,con,360);   //argument must be <=360
  subvar(argument,con,360);
 endwhile();
 while_(var_iable,argument,LT,con,0);     //argument must be >=0
  sumvar(argument,con,360);
 endwhile();
 setvar(direction,var_iable,argument);
endofsub();

beginofsub(pen_);
 if_(var_iable, argument,EQ,con,0);
   setrwd(motor_b);
   on_(motor_b);
   wait(con,210);
   off(motor_b);
 endif();
 if_(var_iable,argument,eq,con,1);
   setfwd(motor_b);
   on_(motor_b);
   wait(con,200);
   off(motor_b);
 endif();
endofsub();
{==========================================}

beginoftask(procedure_);
setvar(argument,con,30);
gosub(cap_);
setvar(argument,con,10);
gosub(forward_);
endoftask();


    end;  //with spirit1
   end    else   messagedlg('Communicationproblem',mterror,[mbOK],0);
end;

end.
